package demo;


import java.net.URL;
import java.security.Security;
import java.util.Hashtable;

import javax.naming.Context;
import javax.naming.InitialContext;
import javax.naming.NamingException;
import javax.security.auth.login.LoginContext;
import javax.security.auth.login.LoginException;

import org.jboss.sasl.JBossSaslProvider;
import org.jboss.security.auth.callback.AppCallbackHandler;

public class RemoteEJBClient {


    static {
        Security.addProvider(new JBossSaslProvider());
    }
    /**
     * User login name
     */
    private static final String USER_LOGIN_NAME = "admin";

    /**
     * User password
     */
    private static final String USER_PASSWORD = "admin";

    private static LoginContext loginContext;
    
    public static final String AUTH_LOGIN_CONFIG = "java.security.auth.login.config";
    
    public static final String AUTH_CONF = "/auth.conf";

    public static void main(String[] args) throws Exception {
        invokeStatelessBean();
    }

    private static void invokeStatelessBean() throws NamingException, LoginException {

        final SessionBeanInterface statelessSessionBeanInterface = lookupRemoteStatelessCalculator();
        System.out.println("Obtained a remote stateless SessionBeanInterface for invocation");
        System.out.println("EJB principal " + statelessSessionBeanInterface.getPrincipal());
    }


    private static SessionBeanInterface lookupRemoteStatelessCalculator() throws NamingException, LoginException {

        if (System.getProperties().getProperty(RemoteEJBClient.AUTH_LOGIN_CONFIG) == null) {
            URL url = RemoteEJBClient.class.getClass().getResource(RemoteEJBClient.AUTH_CONF);
            if (url != null) {
                System.getProperties().setProperty(RemoteEJBClient.AUTH_LOGIN_CONFIG, url.toString());
            }
        }
        
        AppCallbackHandler callbackHandler = new AppCallbackHandler(USER_LOGIN_NAME, USER_PASSWORD.toCharArray());
        loginContext = new LoginContext("logincontextname", callbackHandler);
        loginContext.login();

        final Hashtable jndiProperties = new Hashtable();
        jndiProperties.put(Context.URL_PKG_PREFIXES, "org.jboss.ejb.client.naming");
        final Context context = new InitialContext(jndiProperties);

        final String appName = "TestEAR";
        final String moduleName = "TestEJB";
        final String distinctName = "";
        final String beanName = "SessionBean";
        final String viewClassName = SessionBeanInterface.class.getName();
        System.out.println("ejb:" + appName + "/" + moduleName + "/" + distinctName + "/" + beanName + "!" + viewClassName);
        return (SessionBeanInterface) context.lookup("ejb:" + appName + "/" + moduleName + "/" + distinctName + "/" + beanName
                + "!"
                + viewClassName);
    }

}
